c     ABZUMCHF_LIBRARIES.  MCHF ATOMIC STRUCTURE PACKAGE: SUPPORT LIBRARIES
c     AND UTILITIES.  C.F. FISCHER.            
c     REF. IN COMP. PHYS. COMMUN. 64 (1991) 399
c     Available as:
c     http://www.kfa-juelich.de/zam/CompServ/software/mathe/mathsrc/cpc/abzu.cpc
c     Modified by Nicola Manini to accept large angular momenta in input:
c     if this is not enough, please increase (9000) to some larger value
c     Also added the racahc() function, that provides the right argument order
c     and phase for standard Racah 6-j symbols

*     ----------------------------------------------------------------- ABZU0670
*           F A C T R L                                                 ABZU0671
*     ----------------------------------------------------------------- ABZU0672
*                                                                       ABZU0673
*                                                                       ABZU0674
      SUBROUTINE FACTRL(NFACT)                                          ABZU0675
*                                                                       ABZU0676
*      GAM(I) = LOG( GAMMA(I-1) ), WHERE GAMMA(I) = FACTORIAL I-1       ABZU0677
*                                                                       ABZU0678
      IMPLICIT REAL *8(A-H,O-Z)                                         ABZU0679
*                                                                       ABZU0680
      COMMON/FACT/GAM(9000)                                             ABZU0681
      DATA ZERO,ONE,TWO/0.D0,1.D0,2.D0/                                 ABZU0682
*                                                                       ABZU0683
      GAMMA=ONE                                                         ABZU0684
      GAM(1) = ZERO                                                     ABZU0685
      DO 1 I=1,NFACT-1                                                  ABZU0686
         GAMMA=I*GAMMA                                                  ABZU0687
         GAM(I+1) = DLOG(GAMMA)                                         ABZU0688
    1 CONTINUE                                                          ABZU0689
      DO 20 I = NFACT+1,(9000)                                          ABZU0690
         X = I-1                                                        ABZU0691
         GAM(I) = GAM(I-1) + DLOG(X)                                    ABZU0692
   20 CONTINUE                                                          ABZU0693
      RETURN                                                            ABZU0694
      END                                                               ABZU0695
*                                                                       ABZU0696
*     ----------------------------------------------------------------- ABZU0740
*           G R A C A H                                                 ABZU0741
*     ----------------------------------------------------------------- ABZU0742
*                                                                       ABZU0743
*                                                                       ABZU0744
      SUBROUTINE GRACAH(I,J,K,L,M,N,RAC)                                ABZU0745
      IMPLICIT REAL*8(A-H,O-Z)                                          ABZU0746
*                                                                       ABZU0747
*      SUBROUTINE TO CALCULATE RACAH COEFFICIENTS.                      ABZU0748
*      THE ARGUMENTS I,J,K,L,M,N SHOULD BE TWICE THEIR ACTUAL VALUE.    ABZU0749
*      WRITTEN BY N. S. SCOTT                                           ABZU0750
*      Modified by C. Froese Fischer, March 11, 1988 to use             ABZU0751
*         table look-up                                                 ABZU0752
*                                                                       ABZU0753
      LOGICAL SAVE                                                      ABZU0754
      COMMON/FACT/GAM(9000)                                             ABZU0755
      DIMENSION RACA(0:4,0:4,0:4,0:4,0:4,0:4)                           ABZU0756
      DATA RACA/15625*1.D-20/                                           ABZU0757
      DATA ZERO,ONE,TWO,UNDEF/0.D0,1.D0,2.D0,1.D-20/                    ABZU0758
*                                                                       ABZU0759
      SAVE = .FALSE.                                                    ABZU0760
      IMAX = MAX(I,J,K,L,M,N)                                           ABZU0761
      IF (IMAX .LE. 4) THEN                                             ABZU0762
         RAC = RACA(I,J,K,L,M,N)                                        ABZU0763
         IF (RAC .EQ. UNDEF) THEN                                       ABZU0764
            SAVE = .TRUE.                                               ABZU0765
         ELSE                                                           ABZU0766
            RETURN                                                      ABZU0767
         END IF                                                         ABZU0768
      END IF                                                            ABZU0769
      J1 = I+J+M                                                        ABZU0770
      J2 = K+L+M                                                        ABZU0771
      J3 = I+K+N                                                        ABZU0772
      J4 = J+L+N                                                        ABZU0773
      IF (MOD(J1,2) .EQ. 0  .AND.  MOD(J2,2) .EQ. 0   .AND.             ABZU0774
     :    MOD(J3,2) .EQ. 0  .AND.  MOD(J4,2) .EQ. 0 )  THEN             ABZU0775
          J1 = J1/2                                                     ABZU0776
          J2 = J2/2                                                     ABZU0777
          J3 = J3/2                                                     ABZU0778
          J4 = J4/2                                                     ABZU0779
          IF (MAX(I,J,M) .LE. J1 .AND.  MAX(K,L,M) .LE. J2  .AND.       ABZU0780
     :        MAX(I,K,N) .LE. J3 .AND.  MAX(J,L,N) .LE. J4  )  THEN     ABZU0781
              J5 = (I+J+K+L)/2                                          ABZU0782
              J6 = (I+L+M+N)/2                                          ABZU0783
              J7 = (J+K+M+N)/2                                          ABZU0784
              NUMIN = MAX(J1, J2, J3, J4) + 1                           ABZU0785
              NUMAX = MIN(J5, J6, J7)     + 1                           ABZU0786
              RAC = ONE                                                 ABZU0787
              ICOUNT = 0                                                ABZU0788
              DO 10 KK = NUMIN+1,NUMAX                                  ABZU0789
                KI = NUMAX - ICOUNT                                     ABZU0790
                RAC = ONE - (RAC*(KI*(J5-KI+2)*(J6-KI+2)*(J7-KI+2)))/   ABZU0791
     :                   ((KI-1-J1)*(KI-1-J2)*(KI-1-J3)*(KI-1-J4))      ABZU0792
                ICOUNT = ICOUNT+1                                       ABZU0793
  10          CONTINUE                                                  ABZU0794
              RAC = RAC*EXP(                                            ABZU0795
     :              (GAM(NUMIN+1) - GAM(NUMIN-J1) - GAM(NUMIN-J2) -     ABZU0796
     :               GAM(NUMIN-J3) - GAM(NUMIN-J4) - GAM(J5+2-NUMIN)-   ABZU0797
     :               GAM(J6+2-NUMIN)-GAM(J7+2-NUMIN)) +                 ABZU0798
     :              (GAM(J1+1-I)+GAM(J1+1-J)+GAM(J1+1-M)-GAM(J1+2) +    ABZU0799
     :               GAM(J2+1-K)+GAM(J2+1-L)+GAM(J2+1-M)-GAM(J2+2) +    ABZU0800
     :               GAM(J3+1-I)+GAM(J3+1-K)+GAM(J3+1-N)-GAM(J3+2) +    ABZU0801
     :               GAM(J4+1-J)+GAM(J4+1-L)+GAM(J4+1-N)-GAM(J4+2))/TWO)ABZU0802
              IF (MOD(J5+NUMIN,2) .EQ. 0) RAC = -RAC                    ABZU0803
          ELSE                                                          ABZU0804
              RAC = ZERO                                                ABZU0805
          END IF                                                        ABZU0806
      ELSE                                                              ABZU0807
         RAC = ZERO                                                     ABZU0808
      END IF                                                            ABZU0809
      IF (SAVE) RACA(I,J,K,L,M,N) = RAC                                 ABZU0810
      RETURN                                                            ABZU0811
      END                                                               ABZU0812
*     ----------------------------------------------------------------- 
      function racahc(j1,j2,j3,j4,j5,j6)
c     reorders the arguments of GRACAH and sets the phase to get the Racah 6-j
c     coefficient in accord with the conventions of
c     de-Shalit & Talmi, "Nuclear Shell Theory" (1963)
c     (which, by the way, coincide with those of Mathematica)
c     NB: j1-j6 are still twice the true angular momentum numbers

      implicit none
      real*8 racahc,aa
      integer j1,j2,j3,j4,j5,j6
      call GRACAH(j1,j2,j5,j4,j3,j6,aa)
      racahc=aa*(-1)**((j1+j2+j5+j4)/2)
      return
      end
